| AAX SDK 2.6.1 Avid Audio Extensions Development Kit

- Welcome
- Manual
- Classes
- Files
- Lists
- Support

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
List of all members | Public Member Functions
AAX_ITaperDelegate< T > Class Template Referenceabstract
AAX SDK Manual » AAX Library features » Parameter Manager » Taper delegates

`#include <AAX_ITaperDelegate.h>`

Inheritance diagram for AAX_ITaperDelegate< T >:
[legend]
Collaboration diagram for AAX_ITaperDelegate< T >:
[legend]

## Description

template<typename T>
class AAX_ITaperDelegate< T >

Taper delegate interface template

Classes for conversion to and from normalized parameter values.

Taper delegates are used to convert real parameter values to and from their normalized representations. All taper delegates implement the AAX_ITaperDelegate<T> interface template, which contains two conversion functions:

virtual T NormalizedToReal(double normalizedValue) const = 0;
virtual double RealToNormalized(T realValue) const = 0;
AAX_ITaperDelegate::NormalizedToReal
virtual T NormalizedToReal(double normalizedValue) const =0
Converts a normalized value to a real value.
AAX_ITaperDelegate::RealToNormalized
virtual double RealToNormalized(T realValue) const =0
Normalizes a real parameter value.

In addition, tapers may incorporate logical value constraints via the following interface methods:

virtual T GetMaximumValue() const = 0;
virtual T GetMinimumValue() const = 0;
virtual T ConstrainRealValue(T value) const = 0;
AAX_ITaperDelegate::ConstrainRealValue
virtual T ConstrainRealValue(T value) const =0
Applies a contraint to the value and returns the constrained value.
AAX_ITaperDelegate::GetMaximumValue
virtual T GetMaximumValue() const =0
Returns the taper's maximum real value.
AAX_ITaperDelegate::GetMinimumValue
virtual T GetMinimumValue() const =0
Returns the taper's minimum real value.

For more information, see the AAX_ITaperDelegate class documentation.

## Public Member Functions
virtual AAX_ITaperDelegate * | Clone () const =0
| Constructs and returns a copy of the taper delegate.
virtual T | GetMaximumValue () const =0
| Returns the taper's maximum real value.
virtual T | GetMinimumValue () const =0
| Returns the taper's minimum real value.
virtual T | ConstrainRealValue (T value) const =0
| Applies a contraint to the value and returns the constrained value.
virtual T | NormalizedToReal (double normalizedValue) const =0
| Converts a normalized value to a real value.
virtual double | RealToNormalized (T realValue) const =0
| Normalizes a real parameter value.
Public Member Functions inherited from AAX_ITaperDelegateBase
virtual | ~AAX_ITaperDelegateBase ()
| Virtual destructor.

## Member Function Documentation

## ◆ Clone()

template<typename T >

virtual AAX_ITaperDelegate * AAX_ITaperDelegate< T >::Clone | ( |  | ) | const
| pure virtual

Constructs and returns a copy of the taper delegate.

In general, this method's implementation can use a simple copy constructor:

template <typename T>
AAX_CSubclassTaperDelegate<T>* AAX_CSubclassTaperDelegate<T>::Clone() const
{
return new AAX_CSubclassTaperDelegate(*this);
}

Implemented in AAX_CBinaryTaperDelegate< T >, AAX_CLinearTaperDelegate< T, RealPrecision >, AAX_CLogTaperDelegate< T, RealPrecision >, AAX_CPieceWiseLinearTaperDelegate< T, RealPrecision >, AAX_CRangeTaperDelegate< T, RealPrecision >, and AAX_CStateTaperDelegate< T >.

Referenced by AAX_CParameter< T >::SetTaperDelegate().

Here is the caller graph for this function:

## ◆ GetMaximumValue()

template<typename T >

virtual T AAX_ITaperDelegate< T >::GetMaximumValue | ( |  | ) | const
| pure virtual

Returns the taper's maximum real value.

Implemented in AAX_CBinaryTaperDelegate< T >, AAX_CLinearTaperDelegate< T, RealPrecision >, AAX_CLogTaperDelegate< T, RealPrecision >, AAX_CPieceWiseLinearTaperDelegate< T, RealPrecision >, AAX_CRangeTaperDelegate< T, RealPrecision >, and AAX_CStateTaperDelegate< T >.

## ◆ GetMinimumValue()

template<typename T >

virtual T AAX_ITaperDelegate< T >::GetMinimumValue | ( |  | ) | const
| pure virtual

Returns the taper's minimum real value.

Implemented in AAX_CBinaryTaperDelegate< T >, AAX_CLinearTaperDelegate< T, RealPrecision >, AAX_CLogTaperDelegate< T, RealPrecision >, AAX_CPieceWiseLinearTaperDelegate< T, RealPrecision >, AAX_CRangeTaperDelegate< T, RealPrecision >, and AAX_CStateTaperDelegate< T >.

## ◆ ConstrainRealValue()

template<typename T >

virtual T AAX_ITaperDelegate< T >::ConstrainRealValue | ( | T | value | ) | const
| pure virtual

Applies a contraint to the value and returns the constrained value.

This method is useful if the taper requires a contraint beyond simple minimum and maximum real value limits.

Note
  This is the function that should actually enforces the constraints in NormalizeToReal() and RealToNormalized().

Parameters

  [in] | value | The unconstrained value

Implemented in AAX_CBinaryTaperDelegate< T >, AAX_CLinearTaperDelegate< T, RealPrecision >, AAX_CLogTaperDelegate< T, RealPrecision >, AAX_CPieceWiseLinearTaperDelegate< T, RealPrecision >, AAX_CRangeTaperDelegate< T, RealPrecision >, and AAX_CStateTaperDelegate< T >.

## ◆ NormalizedToReal()

template<typename T >

virtual T AAX_ITaperDelegate< T >::NormalizedToReal | ( | double | normalizedValue | ) | const
| pure virtual

Converts a normalized value to a real value.

This is where the actual taper algorithm is implemented.

This function should perform the exact inverse of RealToNormalized(), to within the roundoff precision of the individual taper implementation.

Parameters

  [in] | normalizedValue | The normalized value that will be converted

Implemented in AAX_CBinaryTaperDelegate< T >, AAX_CLinearTaperDelegate< T, RealPrecision >, AAX_CLogTaperDelegate< T, RealPrecision >, AAX_CPieceWiseLinearTaperDelegate< T, RealPrecision >, AAX_CRangeTaperDelegate< T, RealPrecision >, and AAX_CStateTaperDelegate< T >.

## ◆ RealToNormalized()

template<typename T >

virtual double AAX_ITaperDelegate< T >::RealToNormalized | ( | T | realValue | ) | const
| pure virtual

Normalizes a real parameter value.

This is where the actual taper algorithm is implemented.

This function should perform the exact inverse of NormalizedToReal(), to within the roundoff precision of the individual taper implementation.

Parameters

  [in] | realValue | The real parameter value that will be normalized

Implemented in AAX_CBinaryTaperDelegate< T >, AAX_CLinearTaperDelegate< T, RealPrecision >, AAX_CLogTaperDelegate< T, RealPrecision >, AAX_CPieceWiseLinearTaperDelegate< T, RealPrecision >, AAX_CRangeTaperDelegate< T, RealPrecision >, and AAX_CStateTaperDelegate< T >.

The documentation for this class was generated from the following file:

- AAX_ITaperDelegate.h